<?php
//////////////////////////////////////
//      DISPLAY FOLDER CONTENT      //
//////////////////////////////////////

	// LOAD VIEWFOLDER HELPER CLASS
	require_once(INC_FOLDER .'mg2_view_helper.php');
	require_once(INC_FOLDER .'mg2_viewfolder_helper.php');
	$ViewfolderHelper = &$mg2->getInstance('MG2ViewfolderHelper', $folderID);

	// SEARCH MODE (KEYWORDS), kh_mod 0.4.0 b4, add
	if (defined('SEARCHVIEW')) {
		$folderIDs = array();
		$itemIDs   = $_SESSION[GALLERY_ID]['search']['itemIDs'];
	}
	// GET CONTAINED FOLDERS AND ITEMS, kh_mod 0.4.0 b4, changed
	else {
		$mg2->folderStructure = $mg2->getValidSubfolders($folderID);				// get all sub folders
		$mg2->itemAllocation  = $mg2->getItemAllocation($mg2->folderStructure);	// allocate items to folders
		unset($mg2->folderStructure[$folderID]);
		$folderIDs = array_keys($mg2->folderStructure);
		$itemIDs	  = array_keys($mg2->itemAllocation[$folderID]);
		$mg2->sortIndexDB($folderIDs, 'all_folders', $mg2->folderSortMode);
		$mg2->sortIndexDB($itemIDs, 'all_items', $mg2->imageSortMode);	
	}
	$numFolders = count($folderIDs);
	$numItems   = count($itemIDs);

	// GET DATA FOR CATEGORIES VIEW
	if ($numFolders > 0 && $mg2->foldersetting & 1024) {
		$totalItems				= $numItems;
		$displayView			= 'mg2_categories.php';						// template
		$mg2->thumbViewWidth = '100%';										// thumbs 'justify' to intro
		$mg2->headline			= $mg2->gallerytitle;
	}
	// GET DATA FOR THUMBNAILS VIEW
	else {
		$totalItems				= $numItems + $numFolders;
		$displayView			= 'mg2_thumbnails.php';						// template
		$mg2->thumbViewWidth = 'auto';										// thumbs 'compact'
		$mg2->headline 		= ($folderID === 1 || defined('SEARCHVIEW'))?
									  $mg2->gallerytitle
									  :
									  $mg2->br2line($mg2->all_folders[$folderID][2]);
	}

	// DISPLAY ADMIN MODE AND COUNTER LOCKED
	if (!empty($_SESSION[GALLERY_ID]['adminmode'])) {
		$mg2->headline			= sprintf('%s &ndash; %s', $mg2->lang['adminmode'], $mg2->headline);
		$mg2->lang['clicks'] = sprintf('<span title="%s">%s</span>',
											$mg2->lang['adminmode'],
											$mg2->lang['countlocked']
									  );
	}

	// NAVIGATION AND STARTIMAGE (SLIDESHOW)
	$mg2->breadCrumbNav = $mg2->getBreadCrumbNav($mg2->folderParentID);
	$mg2->startImageURI = (!empty($numItems))?
								 $mg2->getGalleryLink(array('slideshow'=>$itemIDs[0], 'page'=>$currentPage))
								 :
								 '';

	// FOLDER INTRO TEXT SETTINGS, CSS-VALUES, e.g. 90%, 700px
	if ((int)$mg2->introWidth < 1) $mg2->introWidth = 'auto';

	// CATEGORY AND THUMBNAIL ARRANGEMENT
	if ((int)$mg2->layoutsetting & 2048) {
		$mg2->thumbViewWidth = 'auto';			// compact displayed
	}
	elseif ((int)$mg2->layoutsetting & 4096) {
		$mg2->thumbViewWidth = '100%';			// justify displayed
	}

	// DISPLAY EMPTY FOLDER MESSAGE
	if ($numFolders === 0 && $numItems === 0) {
		$ViewfolderHelper->displayGalleryHead();
		include(SKIN_FOLDER .'templates/emptyfolder.php');
		$ViewfolderHelper->displayAdminLink();
		$ViewfolderHelper->displayGalleryFoot();
		return;
	}

	// GET COLS AND ROWS PER PAGE
	list(	$itemCols,
			$itemRows,
			$maxItems,
			$numPages ) = $ViewfolderHelper->getViewGrid($totalItems);

	// CALCULATE FIRST AND LAST ITEM INDEX OF PAGE 
	if ($currentPage === 'all') {
		$first	 = 0;
		$numItems = $totalItems;
	}
	else {
		$currentPage = min($currentPage, $numPages);
		$first		 = $maxItems * ($currentPage - 1);
		$numItems	 = min($totalItems - $first, $maxItems);
	}

	// INCLUDE COLORBOX ADDON
	ob_start();
	include(ADDON_FOLDER .'colorbox/galHeadExtensionThumb.php');
	$mg2->htmlHeadExtension = ob_get_contents();
	ob_end_clean();

	// SWITCH OFF DISPLAY NUMBER OF COMMENTS
	$mg2->foldersetting &= ~256;

	// VIEW FOLDER PAGE
	$itemStartIdx  = $first - ($totalItems - count($itemIDs));
	$numItemBefore = max($itemStartIdx, 0);
	$itemsBefore   = array_slice($itemIDs, 0, $numItemBefore);
	$itemAfterIdx  = max($itemStartIdx + $numItems, 0);
	$itemsAfter    = array_slice($itemIDs, $itemAfterIdx);
	$ViewfolderHelper->displayGalleryHead($slideshow_start_icon, $slideshow_start_text);
	$ViewfolderHelper->displayIntroText();
	$ViewfolderHelper->displayItemsAsLink($itemsBefore);
	$ViewfolderHelper->displayPageNav($currentPage);
	include(INC_FOLDER . $displayView);
	if ($folderID === 1) include(INC_FOLDER .'mg2_loginstatus.php');
	$ViewfolderHelper->displayPageNav($currentPage);
	$ViewfolderHelper->displayItemsAsLink($itemsAfter);
	$ViewfolderHelper->displayAdminLink();
	$ViewfolderHelper->displayGalleryFoot();
?>